#include "gelib.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


namespace gelibspace {

void errorr   (const char* file, int line, const char *format, ...)
{
  char buffer[MAX_MSG_LENGTH];
  va_list args;
  
  va_start(args, format);
  vsprintf(buffer, format, args);
  va_end(args);
  
  fflush (stdout);
  CHANGE_CONSOLE_COLOUR(stderr, TC_D_RED);     fprintf (stderr,"\n\n ERROR:  %s", buffer);
  CHANGE_CONSOLE_COLOUR(stderr, TC_DEFAULT);   fprintf (stderr," (%s:%d).  !!!\n\n", file, line);
  
  throw (201);
}

void warningg (const char* file, int line, const char *format, ...)
{
  char buffer[MAX_MSG_LENGTH];
  va_list args;
  
  va_start(args, format);
  vsprintf(buffer, format, args);
  va_end(args);
  
  fflush (stdout);
  CHANGE_CONSOLE_COLOUR(stderr, TC_D_VIOLET);  fprintf (stderr,"\n\n WARNING:  %s", buffer);
  CHANGE_CONSOLE_COLOUR(stderr, TC_DEFAULT);   fprintf (stderr," (%s:%d).  !!!\n\n", file, line);
}

// void error  (const char *fil, const long lin, const char *str)
// {
//   fprintf (stderr,"\n\n !!!  %s (%s, line %ld).  !!!\n",str,fil,lin);
//   exit (1001);
// }
// 
// void error2 (const char *fil, const long lin, const char *str, const long l, const int ex)
// {
//   fprintf (stderr,"\n\n !!!  %s %ld (%s, line %ld).  !!!\n\n",str,l,fil,lin);
//   if (ex) exit (1002);
// }
// 
// void warning (const char *fil, const long lin, const char *str)
// {
//   fprintf (stderr,"\n\n WARNING:  %s (%s, line %ld).  !!!\n",str,fil,lin);
// }

//* ********************************************************************************************
//* *** *** *** ***                           FILE FCE                           *** *** *** ***
//* ********************************************************************************************

void openFileTest (const FILE *stream,const char *name)
{
  if (stream == NULL)
    _errorr2 ("File has not been opened: %s\n Try it again", name);
}

FILE* openFileN    (const char* File, int Line, const char *mode, const char *key, const char *name)
{
  FILE *f = fopen (name, mode);
  
  if (f == NULL)  errorr (File, Line, "\"%s\" file has not been opened: %s\n Try it again", key, name);
  
  return f;
}


FILE* openFilePN   (const char* File, int Line, const char *mode, const char *key, const char *path, const char *name)
{
  char file[255];
  if (path)  sprintf (file, "%s%s", path, name);
  else       sprintf (file,   "%s",       name);
  
  return openFileN (File, Line, mode, key, file);
}

FILE* openFilePNS  (const char* File, int Line, const char *mode, const char *key, const char *path, const char *name, const char *suff)
{
  char file[255];
  if (path)  sprintf (file, "%s%s%s", path, name, suff);
  else       sprintf (file,   "%s%s",       name, suff);
  
  return openFileN (File, Line, mode, key, file);
}

FILE* openFilePNSS (const char* File, int Line, const char *mode, const char *key, const char *path, const char *name, const char *suff, const char *suff2)
{
  char file[255];
  if (path)  sprintf (file, "%s%s%s%s", path, name, suff, suff2);
  else       sprintf (file,   "%s%s%s",       name, suff, suff2);
  
  return openFileN (File, Line, mode, key, file);
}

} // namespace gelibspace
