#ifndef GELIB_GEOMETRYLIB_H
#define GELIB_GEOMETRYLIB_H

#include "gelib.h"
#include "mathlib.h"
#include "arrays.h"


/**
 * \file 
 * Geometry functions.
 */


namespace gelibspace {

/// ********************************************************************************************
/// *** *** *** ***                      GEOMETRY FUNCTIONS                      *** *** *** ***
/// ********************************************************************************************
int give_edge_points_commperpend_skewlines (const double *l1a, const double *l1b, const double *l2a, const double *l2b, double *p1,  double *p2);
///
long intersec_rectangle3d_line (double zero,double norm,
                                const PoinT *A,const PoinT *B,const PoinT *C,const PoinT *D,
                                const PoinT *U,const PoinT *V,
                                double *ksi,double *eta,double *t,
				PoinT *I1,PoinT *I2);

long intersec_triangle_line (double zero, double norm,
			     const PoinT *A, const PoinT *B, const PoinT *C,
			     const PoinT *U, const PoinT *V,
			     double *ksi, double *eta, double *t,
			     PoinT *I1, PoinT *I2);

long nc_brick_3d (double zero, double x[], double y[], double z[], const PoinT *point, PoinT *answer);

double area3D_Polygon (int n, const PoinT **V, const VectoR *N);
int intersect_RayTriangle (double zero, const PoinT *P0, const PoinT *P1, const PoinT *V0, const PoinT *V1, const PoinT *V2, PoinT* I);


void jac_3d (double &jac, Dvctr &x,Dvctr &y,Dvctr &z,
	     double xi,double eta,double zeta);


} // namespace gelibspace

#endif // GELIB_GEOMETRYLIB_H
