#ifndef GELIB_MATH_H
#define GELIB_MATH_H

//#include <stdio.h>


/**
 * \file 
 * Mathematic functions.
 */


namespace gelibspace {

void shaker (long &n,long *a);
void sort_4 (long *x);
void sort_3 (long *x);
void sort_2 (long *x);
void solve_3 (const double *m,const double *r,double *l);
void solve_3 (const double **m,const double *r,double *l);
long solv_2nle (double zero,const double *a,const double *b,const double *c,const double *d,double *x,double *y);
long solv_2le (double zero,const double *a,const double *b,const double *c,double &x,double &y);
long solv_1le (double zero,double a,double b,double &x);
void nilling (double zero,double &a);
double nillret (double zero,double a);
bool isZero (double zero, double a);
bool isZero (double abszero, double relzero, double a);
long solv_polynom_2 (double zero,double a,double b,double c,double &r1,double &r2);

long div_dd (double d1, double d2, const char* s1, const char* s2, const long line);
long div_dd (long &answer, double d1, double d2);
long div_dd (int &answer, double d1, double d2);

int       decomp_int (int answer[], int n, int       l, int       rad=10);
long      decomp_int (int answer[], int n, long      l, long      rad=10);
long long decomp_int (int answer[], int n, long long l, long long rad=10);

bool isNonZero (double x, double tolerance);

/// Returns the signum of given value (if value is < 0 returns -1, otherwise returns 1)
inline double sgn(double i) { return ( i < 0. ? -1. : 1. ); }

} // namespace gelibspace

#endif // GELIB_MATH_H
