/**
 * \file
 * Main function for testing only.
 */

#include "strut_xalm.h"
#include "librw.h"
#include "gelib.h"



using namespace xalm;

void help (void);

#define VERSION 0.01

/// ********************************************************************************************
/// *** *** *** ***                             MAIN                             *** *** *** ***
/// ********************************************************************************************
int main (int argc, char *argv[])
{
  // version
  if (AP_find_option (argc, argv, "--version")) { fprintf (stdout, "%.2f\n", VERSION); return 0; }
  
  // help
  if (AP_find_option (argc, argv, "--help")) { help(); return 0; }
  
  // detection of paramaters
  if (argc != 1) {
    _warningg("unsupported paramater(s)");
    help();
  }
  
  /// Problem description
  XALM_interface *xi = new XALM_interface();
  
  xi->mtlb();
  xi->solve();
  
  /// DEALOCATION
  if (xi) delete xi;
  
  return 0;
}
// ***  END OF MAIN  ***


/// prints help / syntax
void help (void)
{
  fprintf (stdout,
	   "    Test of XALM library of nonlinear solver  \n"
	   "    Copyright (C) 2013-2014 Ladislav Svoboda  \n"
	   "                                              \n"
	   " SYNTAX   xalmtest [--help|--version]         \n"
	   "                                              \n"
	   " DESCRIPTION				       \n"
	   "					       \n"
	   "  --help    ... print this help               \n"
	   "  --version ... print this help               \n"
	   "                                              \n\n");
}
